// Brush Class    by Alan Baylis 2003

#ifndef Brush_H
#define Brush_H

#include "polygon.h"

// CSG brush class
class BRUSH
{
    public:
        BRUSH();
          ~BRUSH();

        int Compare(const BRUSH& Brush);
        int GetMyPosition() const {return linkPosition;}
        void SetMyPosition(int newPosition) {linkPosition = newPosition;}
        int linkPosition;

        // methods and member variables required to link brushes
        BRUSH* NextBrush;
        bool IsLast();        
        BRUSH* GetNext();
        void AddBrush(BRUSH* Brush);
        void SetNext(BRUSH* Brush);
        BRUSH* CopyList();

        int id;
        int numPolygons;
        POLYGON Polygon[30];

        // operator overloading
        const bool BRUSH::operator == (const BRUSH &Brush) const
        {
            if (id == Brush.id)
            {
                if (numPolygons == Brush.numPolygons)
                {
                    for (int loop = 0; loop < numPolygons; loop++)
                    {
                        if (!(Polygon[loop] == Brush.Polygon[loop]))
                            return false;
                    }
                    return true;
                }
            }
            return false;
        }
};

void DeleteList(BRUSH* Brush);
void InvertBrushPolygons(BRUSH* Brush);
void Set1stVertices();
void Set2ndVertices();
void Set3rdVertices();
void SetBrushPolygons();
void CreateBrushSet();
void ResetBrushes();
void RenderWireframeBrush(BRUSH* Brush);
void RenderTexturedBrush(BRUSH* Brush);
void DrawBrushes();

#endif // BRUSH_H

