// Bullet Class    by Alan Baylis 2002

#ifndef BulletH
#define BulletH

#include "object.h"
#include "vector.h"
#include "vertex.h"
#include "polygon.h"
#include "matrix.h"

class BULLET : public OBJECT
{
    public:
        BULLET();
        ~BULLET();

        void Reset();
        void Initialize();
        void Draw();
        void Delete();

        int active;
        int leaf;
        int flag;
        int collisionnode;
        int collisionpoly;
        VECTOR OriginalPosition;
        VECTOR VelocityVector;
        VECTOR CollisionVector;
        VECTOR PreviousPosition;
        int numverts;
        VERTEX* modelvertlist;
        int numpolys;
        POLYGON* modelpolylist;
        MATRIX Matrix;
};

void InitializeBullets();
void UpdateBullets();
void DeleteBullets();

#endif

