#ifndef GENERAL_H
#define GENERAL_H

#include "shared.h"
#include "polygon.h"
#include "texture.h"
#include "camera.h"
#include "light.h"
#include "bspline.h"
#include "bsp.h"
#include "locmath.h"
#include "tll.h"

float dist_Point_to_Segment(VECTOR P, VECTOR S0, VECTOR S1, VECTOR* Output);
bool CheckForParallelVectors(VECTOR Vect1, VECTOR Vect2);
VECTOR line_plane_collision(VECTOR *a, VECTOR *b, POLYGON *tri1);
int SphereInFrustum(VECTOR point, float radius);
bool PointInFrustum(VECTOR point);
void ExtractFrustum();
void AddSpline(int Number, LinkedList<SPLINE>& SplineList);
void DeleteSpline(int Number, LinkedList<SPLINE>& SplineList);
int LoadSplines(char* SplineFileName, CAMERA* camera, LIGHT* light);
void SetSplines(LinkedList<SPLINE> &);
void SetGLLighting(LIGHT *);
void SetGLCamera(CAMERA *);
void SetGLVertices(VERTEX *);
void SetGLWorld(POLYGON *, TEXTURE *, VERTEX *);
void SetGLProperties();
void SetGLProjection(int Width, int Height);
void SetGLView(int Width, int Height);
void SetGLMaterial();
int SetGLTexture(TEXTURE *);
void DrawMyText();
void DrawGrid();
void DrawWorld(BSP_node *);
void DrawSphere();
void DrawGreenSphere();
void DrawLightSphere(LIGHT *);
void DrawCone();
float GetTimePassed(float &, int, float *);
bool CheckClipPlanes(CAMERA Camera, VECTOR Vect);
void DrawHalo(TEXTURE* texture, LIGHT* light, CAMERA* camera);
void DrawFire(TEXTURE* texture, LIGHT* light, CAMERA* camera);
void DrawBillboards(TEXTURE* texture, LIGHT* light, CAMERA* camera);

#endif //GENERAL_H
