// lightmap and static light structures by Alan Baylis 2001

#ifndef LightmapH
#define LightmapH

#include "vector.h"
#include "texture.h"
#include "polygon.h"

struct BSP_node;

typedef struct StaticLight
{
    VECTOR Position;
    float Brightness;
    float Radius;
    float Red;
    float Blue;
    float Green;
} StaticLight;

typedef struct Lightmap
{
    TEXTURE Texture;
    float vertex_u[3];                   // lightmap uv coordinates
    float vertex_v[3];
} Lightmap;

void SetStaticLights(StaticLight *);
void CreateLightmaps(int numpolys, POLYGON* polylist, Lightmap* lightmaplist, StaticLight* staticlight);
void CreateBSPLightmaps(BSP_node* node);
void LoadBSPLightmaps(BSP_node* node);

#endif

