#include <windows.h>
#include "plane.h"
#include "locmath.h"


PLANE::PLANE()
{
}

PLANE::~PLANE()
{
}

VECTOR GetEdgeIntersection(VECTOR point0, VECTOR point1, PLANE plane, VECTOR pointOnPlane)
{
    VECTOR planeNormal, intersection, temp;
    float numerator, denominator, t;

    // get the splitting planes normal
    planeNormal = plane.normal;

// find edge intersection:
// intersection = p0 + (p1 - p0) * t
// where t = (planeNormal . (pointOnPlane - p0)) / (planeNormal . (p1 - p0))

    //planeNormal . (pointOnPlane - point0)
    temp = pointOnPlane - point0;
    numerator = DotProduct(planeNormal, temp);

    //planeNormal . (point1 - point0)
    temp = point1 - point0;
    denominator = DotProduct(planeNormal, temp);

    if (denominator)
        t = numerator / denominator;
    else
        t = 0.0;

    intersection.x = point0.x + temp.x * t;
    intersection.y = point0.y + temp.y * t;
    intersection.z = point0.z + temp.z * t;

    return intersection;
}

