// Spline functions by Alan Baylis 2003

#include <windows.h>
#include "bspline.h"
#include "locmath.h"
#include "tll.h"


extern int visible;
extern int numSplines;
extern int cameraMode;
extern int currentSpline;
extern int lookAtPath;
extern char* SplineFileName;
extern SPLINE* spline;
extern LinkedList<SPLINE> SplineList;

void AddSpline(int Number)
{
    SPLINE* spline2 = new SPLINE;
    spline2->Active = 1;
    spline2->Repeat = 1;
    spline2->Degree = 3;
    spline2->NumControl = 7;
    spline2->NumPoints = 100;
    spline2->Control = new VECTOR[100];
    spline2->Output = new VECTOR[1000];
    spline2->StartTime = 5000;
    spline2->EndTime = 25000;
    spline2->CopyOfStartTime = spline2->StartTime;
    spline2->CopyOfEndTime = spline2->EndTime;

    spline2->Red = ((float)(rand()%226) + 30.0) / 255;
    spline2->Green = ((float)(rand()%226) + 30.0) / 255;
    spline2->Blue = ((float)(rand()%226) + 30.0) / 255;

    for (int loop = 0; loop < 100; loop++)
    {
        spline2->Control[loop].x = (rand()%60) - 29;  spline2->Control[loop].y = (rand()%60) - 29;  spline2->Control[loop].z = (rand()%60) - 29;
    }

    spline2->linkPosition = Number;   //Set the link position of the spline
    SplineList.Insert(spline2);       //Insert spline in linked list
}

void DeleteSpline(int Number)
{
    SplineList.Delete(Number);
}

int LoadSplines(char* SplineFileName)
{
    const int stringLength = 33;
    char tempString[stringLength];
    FILE* SplineFile;
    SplineFile = fopen(SplineFileName, "rt");
    if (!SplineFile)
    {
        MessageBox(NULL, "Spline File didn't open", "Error", MB_OK | MB_ICONERROR);
        return 0;
    }
    fseek(SplineFile, 0, SEEK_SET);
    int InitialNumSplines = numSplines;
    if (!fgets(tempString, stringLength, SplineFile))
    {
        MessageBox(NULL, "Error reading from the spline data file", "Error", MB_OK | MB_ICONERROR);
        numSplines = InitialNumSplines;
        return FALSE;
    }
    numSplines = atoi(tempString);
    if (InitialNumSplines > numSplines)
    {
        for (int loop = InitialNumSplines - 1; loop >= numSplines; loop--)
        {
            DeleteSpline(loop);
        }
    }
    if (numSplines > InitialNumSplines)
    {
        for (int loop = InitialNumSplines; loop < numSplines; loop++)
        {
            AddSpline(loop);
        }
    }
    for (int loop = 0; loop < numSplines; loop++)
    {
        spline = SplineList.Get(loop);
        // Active flag
        fgets(tempString, stringLength, SplineFile);
        spline->Active = atoi(tempString);
        // Repeat flag
        fgets(tempString, stringLength, SplineFile);
        spline->Repeat = atoi(tempString);
        // Degree
        fgets(tempString, stringLength, SplineFile);
        spline->Degree = atoi(tempString);
        // NumControl
        fgets(tempString, stringLength, SplineFile);
        spline->NumControl = atoi(tempString);
        // NumPoints
        fgets(tempString, stringLength, SplineFile);
        spline->NumPoints = atoi(tempString);
        // StartTime
        fgets(tempString, stringLength, SplineFile);
        spline->StartTime = atof(tempString);
        // EndTime
        fgets(tempString, stringLength, SplineFile);
        spline->EndTime = atof(tempString);
        // Red
        fgets(tempString, stringLength, SplineFile);
        spline->Red = atof(tempString);
        // Green
        fgets(tempString, stringLength, SplineFile);
        spline->Green = atof(tempString);
        // Blue
        fgets(tempString, stringLength, SplineFile);
        spline->Blue = atof(tempString);

        for (int loop2 = 0; loop2 <= spline->NumControl; loop2++)
        {
            fgets(tempString, stringLength, SplineFile);
            spline->Control[loop2].x = atof(tempString);
            fgets(tempString, stringLength, SplineFile);
            spline->Control[loop2].y = atof(tempString);
            fgets(tempString, stringLength, SplineFile);
            spline->Control[loop2].z = atof(tempString);
        }
        spline->CopyOfStartTime = spline->StartTime;
        spline->CopyOfEndTime = spline->EndTime;
    }

    currentSpline = numSplines - 1;
    if (lookAtPath >= numSplines)
        lookAtPath = numSplines - 1;
    if (fclose(SplineFile))
        MessageBox(NULL, "File didn't close", "Error", MB_OK | MB_ICONERROR);
    return 1;
}

void SetSplines()
{
    srand((unsigned)time(NULL));
    //Create a new spline
    for (int loop = 0; loop < numSplines; loop++)
    {
        AddSpline(loop);
    }
    //Load splines from data file
    LoadSplines(SplineFileName);
}

